
(An example of output generated by `fun-with-mastermind.dart`.)

# Fun with Mastermind

In this demonstration we investigate the average number of guesses it
takes to win a game of Mastermind using a simple algorithm:

1. We choose a (fairly) random code from among the remaining eligible codes, and guess it.

2. We use the clues we receive to determine whether we have won, in which case we stop and record the number of moves it took, or not, in which case we use the clues to reduce the number of eligible codes and go back to step 1.

We are investigating the version of the game that has six colors (which we arbitrarily refer to as A, B, C, D, E and F) and four positions.

Clues are represented by the characters `*` (for black, which means that a color is in the correct position) and `o` (for white, which means a color not already accounted for is in an incorrect position).

We will let the computer play 500 games; we will only display the first and last 5 games.
  
Here goes:

## The games...
  
  

### Game 1

The secret code: BCFC

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|FFDA|`  o `|
|2|EDBB|`  o `|
|3|AAAE|`   `|
|4|BCCF|` ** oo `|
|5|BCFC|` ****  `|

Solved in 5 guesses.

### Game 2

The secret code: CCCA

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|CBFB|` *  `|
|2|AAAB|`  o `|
|3|CCCA|` ****  `|

Solved in 3 guesses.

### Game 3

The secret code: AECC

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|FEDE|` *  `|
|2|AAAE|` * o `|
|3|ABDA|` *  `|
|4|AECC|` ****  `|

Solved in 4 guesses.

### Game 4

The secret code: FEEF

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|BAFA|`  o `|
|2|ACCC|`   `|
|3|DBBB|`   `|
|4|EEEF|` ***  `|
|5|EFEF|` ** oo `|
|6|FEEF|` ****  `|

Solved in 6 guesses.

### Game 5

The secret code: FFDF

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|EBEA|`   `|
|2|CCCC|`   `|
|3|DDDD|` *  `|
|4|DFFF|` ** oo `|
|5|FDFF|` ** oo `|
|6|FFDF|` ****  `|

Solved in 6 guesses.

### Game 496

The secret code: BFFA

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|BDCE|` *  `|
|2|AAAE|`  o `|
|3|BBBA|` **  `|
|4|BFFA|` ****  `|

Solved in 4 guesses.

### Game 497

The secret code: EDBD

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|BEDC|`  ooo `|
|2|DBFE|`  ooo `|
|3|ADEB|` * oo `|
|4|EDBD|` ****  `|

Solved in 4 guesses.

### Game 498

The secret code: FAAA

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|AABD|` * o `|
|2|ABCB|`  o `|
|3|BDDD|`   `|
|4|EAAA|` ***  `|
|5|EAAE|` **  `|
|6|FAAA|` ****  `|

Solved in 6 guesses.

### Game 499

The secret code: AAAE

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|FDCF|`   `|
|2|AEBA|` * oo `|
|3|AAAB|` ***  `|
|4|AAAE|` ****  `|

Solved in 4 guesses.

### Game 500

The secret code: CBBC

|Guess number|Guess|Clues|
|:--:|:--|:--|
|1|FECF|`  o `|
|2|CADD|` *  `|
|3|AAAE|`   `|
|4|BBFD|` * o `|
|5|CBBB|` ***  `|
|6|CBBC|` ****  `|

Solved in 6 guesses.
## Summary

In 500 games, the computer found the code in at least 1 guesses, at most 8 guesses, and on average 4.890 guesses.

Thanks for your interest! Please let me know if you find any interesting use cases for this library!

Richard Ambler rambler@ibwya.net


